// COPYRIGHT (c) 2002 PLOTNIX, INC. All rights reserved

package com.plotnix.jex;

/**
 * Compiled form of a value expression, which can be evaluated in
 * a {@link Context Context}.
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public interface Expression {

    /**
     * Produces the value described by the expression in the
     * specified context with the supplied arguments.
     * 
     * @param context is an evaluation context.
     * @param arguments are argument of the expression. Can be null
     *  if the expression does not take any arguments.
     * @return the result of the evaluation of this expression
     */
    Object evaluate(Context context, Object[] arguments);

    /**
     * Evaluates the expression and casts the result to the supplied type.
     * 
     * @see #evaluate(Context, Object[])
     */
    Object evaluate(Context context, Object[] arguments, Class valueType);
}
