// COPYRIGHT (c) 2002 PLOTNIX, INC. All rights reserved

package com.plotnix.jex.jxpath;

import com.plotnix.jex.Context;
import org.apache.commons.jxpath.Variables;

/**
 * Wraps Jex variables into JXPath variables.  This object points to
 * a Jex context and works with variables from that context.
 * <p>
 * If Jex becomes a part of Jakarta, JXPath will change to implement
 * Jex interfaces directly.  At that point the need for this adaptor
 * will disappear.
 *
 * @author Dmitri Plotnikov
 * @version $Revision$
 */
public class JXPathVariables implements Variables {

    private Context context;

    /**
     * @param context is the Jex context that hosts the variables
     * represented by the new object.
     */
    public JXPathVariables(Context context){
        this.context = context;
    }
        
    /**
     * @see Variables#isDeclaredVariable(String)
     */
    public boolean isDeclaredVariable(String varName) {
        return context.getVariables().isDeclaredVariable(varName);
    }

    /**
     * @see Variables#getVariable(String)
     */
    public Object getVariable(String varName) {
        return context.getVariables().getVariable(varName);
    }

    /**
     * @see Variables#declareVariable(String, Object)
     */
    public void declareVariable(String varName, Object value) {
        context.getVariables().declareVariable(varName, value);
    }
}
